<template>
  <form
    class="p-2 flex flex-col justify-center gap-4"
    @submit.prevent.stop="createProject"
  >
    <div class="flex flex-row justify-around gap-2 items-center">
      <label for="projectName">Nome:</label>
      <BaseInput
        id="projectName"
        v-model="name"
        placeholder="Projeto-X"
        required
      />
    </div>
    <div class="flex flex-row justify-center">
      <BaseButton
        type="submit"
        label="Cadastrar"
        class="border border-success-300 border-opacity-40 rounded bg-success-300 bg-opacity-20"
      >
        <PlusIcon class="h-5 w-5" />
      </BaseButton>
    </div>
  </form>
</template>

<script>
import { PlusIcon } from '@vue-hero-icons/outline'
import BaseInput from '../ui/BaseInput.vue'
import BaseButton from '../ui/BaseButton.vue'
import { getAxiosHeaders } from '~/utils/utils'
import Project from '~/classes/Project'
export default {
  name: 'CreateProject',
  components: {
    BaseButton,
    BaseInput,
    PlusIcon,
  },
  data() {
    return {
      name: null,
    }
  },
  computed: {
    projects() {
      return this.$store.state.projects.list
    },
  },
  methods: {
    async createProject() {
      if (this.verifyProjectName(this.name)) {
        return this.$toast.info('Projeto já cadastrado', {
          closeOnSwipe: true,
          duration: 3000,
        })
      }
      try {
        await this.$axios
          .$post(
            'addOneProject',
            { name: this.name },
            getAxiosHeaders(this.$auth)
          )
          .then((response) => {
            if (response.status.is_error) {
              return this.$toast.error(
                'Ocorreu um erro ao cadastrar projeto.',
                {
                  closeOnSwipe: true,
                  duration: 3000,
                }
              )
            }
            this.$store.commit(
              'projects/createProject',
              new Project({ ...response.data.project })
            )
            this.$toast.success(
              `Projeto ${response.data.project.name} cadastrado com sucesso!`,
              {
                closeOnSwipe: true,
                duration: 2000,
              }
            )
            this.$emit('close')
          })
      } catch (error) {
        // eslint-disable-next-line no-console
        console.warn(error)
        this.$toast.error('Ocorreu um erro inesperado...', {
          closeOnSwipe: true,
          duration: 2000,
        })
      }
    },
    verifyProjectName(name) {
      const searchName = this.projects.find(
        (project) => project.name() === name
      )
      return searchName
    },
  },
}
</script>
